//============================================================================
// Name        : serialpatchdemo.cpp
// Author      : Andrey Mandychev
// Version     :
// Copyright   :
// Description : The program demonstrates reconnection facility of serial
//               port /dev/ttyUSB0 serviced by SerialService class object.
//============================================================================

#include <iostream>
#include <cc++/serial.h>

using namespace std;
using namespace ost;

class AppSerialPort : public SerialPort
{
public:
  AppSerialPort(SerialService *svc, const char* name) : SerialPort(svc, name) {}
  virtual ~AppSerialPort() {}


private:
  void pending() { cout << "onPending" << endl;}
  void expired() { cout << "onExpired" << endl;}
  void disconnect()
  {
    cout << "onDisconnect" << endl;
    delete this;
  }
  void output() { cout << "onOutput" << endl;}
};

int main() {
  SerialService *service = new SerialService;
  AppSerialPort *port = NULL;

  cout << "Serial patch demo" << endl;
  for(;;) {
    if (!port) {
      try {
        port = new AppSerialPort(service, "/dev/ttyUSB0");
        cout << "connected" << endl;
      }
      catch (...) {}
      ::sleep(1);
    }
    else {
      if (!service->getCount())
        port = NULL;
    }
  }
  return 0;
}
